import 'package:ingdao/dataflow/control/dfquery.dart';
import 'package:ingdao/dataflow/entity/dfbaseentity.dart';
import 'package:ingdao/dataflow/entity/dfwebentity.dart';
import 'package:ingdao/dataflow/field/dfbasefield.dart';
import 'package:ingdao/dataflow/field/dfwebfield.dart';
import '../field/response_field.dart';
import 'package:ingdao/dataflow/field/dffieldtype.dart';
import 'package:object_mapper/object_mapper.dart';
import 'updatedetailsweb.dart';

class ResponseWeb extends DfWebEntity with ResponseField {

  bool success;
  UpdateDetailsWeb data;

  ResponseWeb ({bool pSuccess, UpdateDetailsWeb pData}) : super(contextPath: "") {
    fSuccess = DfWebField(entity: this, name: "success", fieldType: DfFieldType.boolean(), getObjectValue: () => success, setObjectValue: (v) => success = v, value: pSuccess);
    fData = DfWebField(entity: this, name: "data", fieldType: DfFieldType.custom(), getObjectValue: () => data, setObjectValue: (v) => data = v, value: pData);
  }

  //Define what are the fields will map back the result from http response Map<String,dynamic>
  @override
  List<DfWebField> fields() {
     return [fSuccess,
            fData,
            ];
  }

  @override
  DfWebReqParam convertToWebReqParam(DfQuery query) {
    return null;
  }

  @override
  DfBaseEntity<DfBaseField> newInstance() {
    return ResponseWeb();
  }

  @override
  DfBaseEntity<DfWebField> jsonToObject(DfQueryPurpose purpose, Mapper map) {
  }

  @override
  void customFieldJsonMap(Mapper map, List<DfWebField> fields) {
    for (var field in fields) {
      if (field == fData) {
        map<UpdateDetailsWeb>(field.name, field.getObjectValue(), (v) => field.setObjectValue(v), field.getTransform());        
      }
    }
  }
}